Page MenuHomeFreeBSD

vt(4): Enable vt(4) by default
ClosedPublic

Authored by dumbbell on Oct 23 2014, 10:53 PM.

Details

Summary

According to the few reports we get now, I think we fixed all major problems. Therefore, I believe it's ready for wider testing. What do you think?

Diff Detail

Repository
rS FreeBSD src repository
Lint
No Linters Available
Unit
No Unit Test Coverage

Event Timeline

dumbbell updated this revision to Diff 2100.Oct 23 2014, 10:53 PM
dumbbell retitled this revision from to vt(4): Enable vt(4) by default.
dumbbell updated this object.
dumbbell edited the test plan for this revision. (Show Details)
dumbbell added reviewers: ray, emaste, nwhitehorn.
emaste edited edge metadata.Oct 24 2014, 2:16 AM

I generally agree.

We need an answer for the lack of non-UTF-8 charmaps though, and need to make a clear announcement when this gets committed, including mention of the limitations.

nwhitehorn edited edge metadata.Oct 24 2014, 3:24 AM

I agree too. Not an MFC candidate, but something that's a good idea. vt supports at least all of the hardware that syscons does now.

In D1005#3, @emaste wrote:

We need an answer for the lack of non-UTF-8 charmaps though, and need to make a clear announcement when this gets committed, including mention of the limitations.

Yes, I'll prepare a draft on Monday.

To my knowledge, the limitations and known issues are:

  • Several vidcontrol(1) features are not implemented in vt(4) yet. For instance:
    • modesetting
    • buffer history capture (-p and friends)
  • moused(8) isn't supported in VGA text mode.
  • The text cursor may end up in the middle of kernel messages after loading a kernel video driver.
  • vt(4) expects UTF-8 input.
  • vt(4) is limited to 16 colors.
  • vt(4) doesn't support syscons splash screens.

Do you see something else? Are there other problems with UEFI or non-amd64 platforms?

ray accepted this revision.Oct 24 2014, 12:49 PM
ray edited edge metadata.

At least vt(4) currently less problematic than syscons(4) :-D

This revision is now accepted and ready to land.Oct 24 2014, 12:49 PM

https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=153459
https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=188039
https://bugs.freebsd.org/bugzilla/show_bug.cgi?id=194112

The keymap selection is the important bit there, I think. The installer keymap selection got rewritten as part of bsdconfig, so I no longer know how it works. Maybe Devin can take a look?

The screen clearing issue I find mystifying, but it's merely ugly. VGA text mode isn't really important anymore since graphics mode works well. If it weren't for some BIOSes that capture VGA text to serial, I'd even suggest getting rid of it. We can't meaningfully do modesetting without a VESA driver.

The screen clearing issue I find mystifying, but it's merely ugly.

Yes, it's a cosmetic bug and it doesn't appear in the currently common cases anyway (BIOS boot on amd64 with VGA).

VGA text mode isn't really important anymore since graphics mode works well. If it weren't for some BIOSes that capture VGA text to serial, I'd even suggest getting rid of it. We can't meaningfully do modesetting without a VESA driver.

We have a few different modesetting aspects to consider:

  • VGA text modes: 80x50, 80x60, etc.
  • VGA VESA modes.
  • interface to driver modesetting capabilities (e.g. i915kms or radeon) for which we have no infrastructure today

The latter is the most interesting I think.

dumbbell added a comment.EditedOct 27 2014, 10:33 AM
  • Inability to unload a video kernel driver

I admit this "regression" is mainly for me, while I'm working on radeonkms :-) And I didn't finish the patch in D687 yet.

I'm going to document all these known issues on the wiki and put a shorter version in the announcement.

In D1005#9, @emaste wrote:
  • No vgl(3) support (I am not sure anyone uses it)

What about deprecating/removing it?

Mostly looks good to me. I'd phrase a few of the points in a more positive way, though, and also define the terms. "No modesetting" makes it sound like KMS isn't supported, for example, which it most certainly is.

o  The keymap selection in bsdconfig (used in the installer) has not been updated to use the vt keymap list instead of the syscons one
o  Only UTF-8 character maps
o  The console resolution is currently fixed to the value chosen by the underlying graphics driver
o  No support for several vidcontrol(1) features.
o  Graphics features such as mouse pointers and font setting work only in VGA graphics mode, not in VGA text mode.

It's probably worth also adding a list of features to go with the list of bugs.

I sent mail to FreeBSD-current looking for vgl users to help determine porting priority.

Thanks for the comments, I updated the draft, available at the same location.

That looks perfect to me. Thanks!

I said in the HEADS UP that the switch was today.

Any objection?

dumbbell updated this revision to Diff 2259.Nov 3 2014, 11:32 PM
dumbbell edited edge metadata.

Changes since the last patch:

  • Add an UPDATING entry
  • Bump FreeBSD_version
dumbbell updated this revision to Diff 2260.Nov 3 2014, 11:40 PM

Changes since last patch:

  • Add more information to the UPDATING entry
dumbbell updated this revision to Diff 2263.Nov 4 2014, 8:56 AM

Changes since the last patch:

  • Rephrase UPDATING entry
dumbbell updated this revision to Diff 2264.Nov 4 2014, 9:53 AM

Changes since the last patch:

  • Rephrase UPDATING entry
dumbbell closed this revision.Nov 4 2014, 10:32 AM

Committed in rS274085.